/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VMaelstromAnnotationRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VMaelstromAnnotation extends TableImpl<VMaelstromAnnotationRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_maelstrom_annotation</code>
     */
    public static final VMaelstromAnnotation V_MAELSTROM_ANNOTATION = new VMaelstromAnnotation();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VMaelstromAnnotationRecord> getRecordType() {
        return VMaelstromAnnotationRecord.class;
    }

    /**
     * The column <code>common_dd.v_maelstrom_annotation.unique_name</code>.
     */
    public final TableField<VMaelstromAnnotationRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_maelstrom_annotation.annotation</code>.
     */
    public final TableField<VMaelstromAnnotationRecord, JSONB> ANNOTATION = createField(DSL.name("annotation"), SQLDataType.JSONB, this, "");

    private VMaelstromAnnotation(Name alias, Table<VMaelstromAnnotationRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VMaelstromAnnotation(Name alias, Table<VMaelstromAnnotationRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_maelstrom_annotation" as  WITH x(u, d, a) AS (
                SELECT h.unique_name,
                   split_part(a.key, '::'::text, 1) AS d,
                   jsonb_object_agg(split_part(a.key, '::'::text, 2), a.value) AS jsonb_object_agg
                  FROM ((common_dd.t_core_annotation a
                    LEFT JOIN common_dd.t_core_element_hierarchy h ON ((h.key_element = a.fk_element)))
                    LEFT JOIN common_dd.t_core_variable v ON ((v.key_variable = h.key_element)))
                 WHERE (lower((a.source)::text) = ANY (ARRAY['maelstroem'::text, 'maelstrom'::text]))
                 GROUP BY h.unique_name, a.source, (split_part(a.key, '::'::text, 1))
               )
        SELECT u AS unique_name,
           jsonb_object_agg(d, a) AS annotation
          FROM x
         GROUP BY u;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_maelstrom_annotation</code> table
     * reference
     */
    public VMaelstromAnnotation(String alias) {
        this(DSL.name(alias), V_MAELSTROM_ANNOTATION);
    }

    /**
     * Create an aliased <code>common_dd.v_maelstrom_annotation</code> table
     * reference
     */
    public VMaelstromAnnotation(Name alias) {
        this(alias, V_MAELSTROM_ANNOTATION);
    }

    /**
     * Create a <code>common_dd.v_maelstrom_annotation</code> table reference
     */
    public VMaelstromAnnotation() {
        this(DSL.name("v_maelstrom_annotation"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VMaelstromAnnotation as(String alias) {
        return new VMaelstromAnnotation(DSL.name(alias), this);
    }

    @Override
    public VMaelstromAnnotation as(Name alias) {
        return new VMaelstromAnnotation(alias, this);
    }

    @Override
    public VMaelstromAnnotation as(Table<?> alias) {
        return new VMaelstromAnnotation(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VMaelstromAnnotation rename(String name) {
        return new VMaelstromAnnotation(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VMaelstromAnnotation rename(Name name) {
        return new VMaelstromAnnotation(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VMaelstromAnnotation rename(Table<?> name) {
        return new VMaelstromAnnotation(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromAnnotation where(Condition condition) {
        return new VMaelstromAnnotation(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromAnnotation where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromAnnotation where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromAnnotation where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromAnnotation where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromAnnotation where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromAnnotation where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VMaelstromAnnotation where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromAnnotation whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VMaelstromAnnotation whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
